apps/pro/ui/config/routes.rb
        end
      end
    end
  end

  # Notifications
  namespace :notifications do
    resources :messages do
      collection do
        post 'mark_read' => 'messages#mark_read', :as => 'mark_read'
        get 'poll' => 'messages#poll', :as => 'poll'
      end
    end
  end

  # Setup & Licenses
  scope "/setup" do
    get ""           => "licenses#setup", :as => "setup"
    get "request"    => "licenses#request_key", :as => "request_key"
    get "activation" => "licenses#activation", :as => "activation"
  end

  scope "/licenses" do
    get ""        => "licenses#index",    :as => "licenses"
    post "register" => "licenses#register", :as => "register"
    post "activate" => "licenses#activate", :as => "activate"
    match "offline_activation" => "licenses#offline_activation", :as => "offline_activation", :via => [:get, :post]
  end

  # Updates
  scope "/updates" do
    get ""             => "updates#updates", :as => "updates"
    post "check"         => "updates#check"
    post "apply"         => "updates#apply"
    post "restart"       => "updates#restart"
    post "status"        => "updates#status"
    get  "offline_apply" => "updates#offline_apply"
    post "offline_apply_post" => "updates#offline_apply_post", :as => 'updates_offline_apply_post'
  end

  # NeXpose Consoles
  resources :nexpose_consoles do
    collection do
      delete "/destroy" => "nexpose_consoles#destroy", :as => "destroy"
    end
  end

  # API Keys
  resources :api_keys do
    collection do
      delete "/destroy" => "api_keys#destroy", :as => "destroy"
    end

    member do
      post "/reveal" => "api_keys#reveal"
    end
  end



  # Macros
  resources :macros
  scope "/macro" do
    delete ":id/delete_action/:action_id" => "macros#delete_action", :as => "macro_delete_action"
    delete ":id/delete_action" => "macros#delete_action", :as => "macro_delete_actions"
    post ":id/add_action" => "macros#add_action", :as => "macro_add_action"
    match "module_options" => "macros#module_options", :as => "module_options", via: [:get, :post]
  end
  delete "macros" => "macros#destroy", :as => "delete_macros"


  # Listeners
  resources :listeners
  scope "/listener" do
    post ":id/stop" => "listeners#stop", :as => "listener_stop"
    post ":id/start" => "listeners#start", :as => "listener_start"
    get "module_options" => "listeners#module_options", :as => "macro_module_options"
  end
  delete "listeners" => "listeners#destroy", :as => "delete_listeners"


  # Global Settings
  scope "/settings" do
    get "" => "settings#index", :as => "settings"
    patch "update_profile" => "settings#update_profile", :as => "update_profile"
    put "update_profile" => "settings#update_profile"
  end


  # Mdm::User settings
  resources :users

  get "login" => "user_sessions#new", :as => "login"
  get "logout" => "user_sessions#destroy", :as => "logout"

  resources :user_sessions

  # Workspaces
  get "/workspaces/search" => "workspaces#search"
  delete "/workspaces/destroy" => "workspaces#destroy"

  # Wizard related reporting routes
  get '/wizard_report_tab' => 'reports#form_for_tabbed_modal', :as => 'wizard_report_tab_form'

  resources :workspaces do
    get "sessions" => "sessions#index"
    get "events" => "events#index"
    get "web" => "web#index"

    resources :imports, only: [:new]


    # Reports and Exports
    # Standard reports
    resources :reports do
      collection do
        post  "validate_report" => "reports#validate_report", :as=> "validate_report"
        # Wrapper to allow all the other report partials
        # to be reloaded once type is selected:
        get :form_for_type
        delete :destroy_multiple
      end
      member do
        get :clone
        post :generate_format
        post :format_generation_status
      end

      # Generated report files
      resources :report_artifacts, only: [:destroy, :index] do
        member do
          get :download
          get :view
        end

        collection do
          post :email
        end
      end
    end

    # Outside of reports to avoid dealing with report IDs unnecessarily:
    get 'report_artifact_download/(:id)',       to: 'report_artifacts#download'
    get 'report_artifact_view/:id',             to: 'report_artifacts#view'

    # Custom reports
    resources :custom_reports, { :controller => :reports }

    # Resources for custom reports: logos, templates
    resources :report_custom_resources

    # Example simple template
    get 'report_template_simple_download',      to: 'reports#download_simple_sample'

    resources :exports do
      member do
        get 'download' => 'exports#download'
      end
      collection do
        delete :destroy_multiple
      end
    end

    resources :task_chains, except: [:show] do
      collection do
        post "validate_schedule" => 'task_chains#validate_schedule', :as => 'validate_schedule'
        post "validate" => 'task_chains#validate', :as=>'validate'
        delete :destroy_multiple
        post   :stop_multiple
        post   :suspend_multiple
        post   :resume_multiple
        post   :start_multiple
      end

      member do
        get :clone
      end
    end

    namespace :fuzzing do
      resources :fuzzing do
        resources :request_groups
      end
    end

    namespace :nexpose do
      namespace :result do
        # fixme: CHANGE TO POST TO PREVENT CSRF.
        get 'push_validations' => 'exceptions#push_validations'
        resources :exceptions, only: [:create, :show, :update]
        resources :validations, only: [:create, :show, :update]
      end
      namespace :data do
        resources :sites, only: [:index] do
          collection {
            get :search_operators
            get :filter_values
          }
        end
        resources :import_runs, only:[:create,:show]
      end
    end


    # NEW STYLE!
    # Social Engineering Campaigns
    namespace :social_engineering do
      resources :human_targets

      resources :web_templates, except: [:delete] do
        collection do
          post :clone_proxy
          delete "" => "web_templates#destroy", :as => "delete"
        end
      end

      resources :email_templates, except: [:delete]  do
        collection do
          delete "" => "email_templates#destroy", :as => "delete"
        end
      end

      resources :target_lists, except: [:delete]  do
        get "export" => "target_lists#export"
        post "remove_targets" => "target_lists#remove_targets"
        collection do
          delete "" => "target_lists#destroy", :as => "delete"
        end
      end

      resources :files, except: [:delete]  do
        collection do
          delete "" => "files#destroy", :as => "delete"
        end
      end

      # ------ Campaigns, components, and tracking data -----
      resources :campaigns do

        resource :web_server_config, {
            :only => [:edit, :update],
            :controller => :web_server_config
        }
        resource :email_server_config, {
            :only => [:edit, :update],
            :controller => :email_server_config
        } do
          collection do
            match :check_smtp, via: [:put, :patch]
          end
        end

        resources :visits

        resources :emails do
          get :preview
          get :preview_pane
          collection do
            post :custom_content_preview
          end
        end

        resources :web_pages do
          get :preview
          get :preview_pane
          collection do
            post :clone_proxy
            post :custom_content_preview
          end
        end

        resources :portable_files do
          member do
            get :download
          end
        end

        member do
          post :execute
          post :reset
          get  :to_task
          get  :sent_emails
          get  :opened_emails
          get  :opened_sessions
          get  :submitted_forms
          get  :links_clicked
          get  :check_for_configuration_errors
        end

        collection do
          delete "" => "campaigns#destroy", :as => "delete"
          get :logged_in
        end
        resources :phishing_results, :only => [:index, :show]
      end
    end
    # ------ RunStat -----
    resources :run_stats, :only => [:show]


    # ------ WebScan -----
    resources :web_scans, :only => [:show]


    delete "/tags/destroy" => "tags#destroy"
    resources :tags do
      collection do
        delete :destroy, :as => "destroy"
        get :search
      end
    end

    resources :loots, :only => [:index, :destroy] do
      collection do
        delete :destroy_multiple
      end
    end

    #Creds Management
    resources :creds, :only => [:index] do
    end


    # Notes, Services
    [:notes, :services].each do |res|
      resources res, :only => [:index] do
        collection do
          get :combined
          delete :destroy_multiple
        end
      end
    end

    # Note Creation
    resources :notes, only: [:create]


    # Module Detail
    resources :module_details, only:[:show]


    # Vulnerabilities
    resources :vulns, :only => [:index, :show] do
      collection do
        get :combined
        delete :destroy_multiple
        delete :destroy_multiple_groups
      end

      member do
        get  :history
        get  :related_modules
        get  :related_hosts
        get  :related_hosts_filter_values
        get  :search_operators
        put  :update_last_vuln_attempt_status
        put  :restore_last_vuln_attempt_status
      end

    end

    get "vulns/:id/details"  => "vulns#details", :as => "vuln_details"
    get "vulns/:id/attempts" => "vulns#attempts", :as => "vuln_attempts"
    get "vulns/:id/exploits" => "vulns#exploits", :as => "vuln_exploits"

    namespace :apps do

      namespace :single_password do
        resources :task_config do
          get 'show_creds', :on => :collection
        end
      end

      namespace :ssh_key do

apps/pro/ui/app/controllers/exports_controller.rb
class ExportsController < ApplicationController

  before_filter :load_workspace

  def index
    @exports = @workspace.exports
    respond_to do |format|
      format.html do
        render :action => "index", :layout => "application"
      end
      format.json do
        render :json => DataTableQueryResponse.build(params, {
          :collection => @exports,
          :search_cols => [:file_path, :created_by,
                           :state, :export_type],
          :columns => [:id, :file_path, :etype, :created_by, :state,
                       :created_at, :actions],
          :render_row => lambda { |export|
            { :file_path => File.basename(export.file_path), :etype => export.etype.pretty_name }
          }
        })
      end
    end
  end

  def new
    @export = Export.new(:export_type => :xml)
  end

  def create
    params[:export] ||= {}
    export_params = params[:export].merge(:workspace_id => @workspace.id)
    @export = Export.new(export_params)
    @export.created_by = current_user.username

    unless @export.save
      render :action => 'new',
             :locals => {:export => @export,
                         :error => @export.errors.full_messages.join('<br/>')
             },
             :status => :error
      return
    end

    # Adds export generation process to DJ queue:
    @export.generate_delayed
    flash[:notice] = 'Export creation queued. Table will refresh shortly...'
    redirect_to workspace_exports_path(@workspace)
  end

  def download
    @export = Export.find(params[:id])
    export_filename = File.basename(@export.file_path)
    export_extension = File.extname(@export.file_path)[1..-1]

    file_types = {
        'xml'  => 'application/xml',
        'txt'  => 'text/plain',
        'zip'  => 'application/zip'
    }
    current_type = file_types[export_extension]

    file_data = File.open(@export.file_path, 'rb') { |f| f.read }
    # Prompt for file download:
    send_data(file_data,
              :type => current_type,
              :filename => export_filename)
  end

  def destroy
    @export.destroy
    flash[:notice] = "Deleted export #{@export.file_path}."
  end

  def destroy_multiple
    Export.destroy_all(id: params[:export_ids],
                       workspace_id: @workspace.id)

    respond_to do |format|
      format.any(:html, :js) do
        # TODO Not showing up
        flash.now[:notice] = "Deleted #{export_ids.size} exports."
        redirect_to workspace_exports_path(@workspace)
      end
      format.json {
        render :json => { success: true }
      }
    end
  end

end

apps/pro/ui/app/views/exports/_address_settings.html.erb
<% unless @export.export_type == :mm_segment %>
    <%= f.inputs 'Address Settings' do -%>
        <%= f.input :included_addresses,
                    :label        => 'Included addresses',
                    :as           => :text,
                    :required     => false,
                    :wrapper_html => {:id => 'export_included_addresses_input'}
        %>
        <%= f.input :excluded_addresses,
                    :label        => 'Excluded addresses',
                    :as           => :text,
                    :required     => false,
                    :wrapper_html => {:id => 'export_excluded_addresses_input'}
        %>
    <% end -%>

    <%= f.help_link 'included_addresses' do %>
        <h3>Included and Excluded Addresses</h3>
        <p>Specify <b>Included Addresses</b> and <b>Excluded Addresses</b> to configure the scope of the export, or leave blank to include all the hosts associated with this project. Hosts with addresses outside the allowable range(s) will not be included in the exported data. Entries may be specified as single addresses (192.168.1.1), dashed entries (192.168.1.1-192.168.1.100), wildcards (192.168.1.*), or using CIDR notation (192.168.1.0/29).</p>
    <% end %>
<% end %>

apps/pro/ui/app/views/exports/_export_name.html.erb
<%= f.inputs 'Name' do -%>
    <%= f.input :name,
                :required => true
    %>
<% end %>

<%= f.help_link 'name' do %>
    <h3>Export name</h3>
    <p>The name to use in creating the export file. The file extension is added automatically based on the selected export type, so only the base name needs to be specified (e.g. an XML export named 'Engagement1' will result in INSTALL_PATH/pro/exports/Engagement1.xml)</p>
<% end %>

apps/pro/ui/app/views/exports/_export_nav_bar.html.erb
<div id='export_nav_bar'>
	<div class='control-bar-items'>
		<span class='button any'><%= link_to 'Delete', destroy_multiple_workspace_exports_path(@workspace, :format => :json), :confirm => 'Delete selected exports?', :id => 'user-delete-submit' %></span>
		<div class='separator'></div>
		<span class='button'><%= link_to 'Export Data', new_workspace_export_path(@workspace), :class => :export_data %></span>
	</div>
</div>

apps/pro/ui/app/views/exports/_export_options.html.erb
<%= f.inputs 'Options' do -%>
    <%= f.input :mask_credentials,
                :as => :boolean %>

    <%= f.help_link 'mask_credentials' do %>
        <h3>Export Options</h3>
        <p>Mask credentials: select this option to obfuscate any display of credential values in the resultant export. Note that this will not be applied to existing artifacts included in some exports, e.g. existing reports that are exported in a Zip Workspace export.</p>
    <% end %>
<% end %>

apps/pro/ui/app/views/exports/_export_type.html.erb
<% @export_type_map = Export::EXPORT_TYPE_MAP %>
<% @export_types = @export_type_map.keys.sort %>

<%= f.inputs "Export Type" do %>
    <%= f.input :export_type,
                :collection => @export_types,
                :as => 'select',
                :include_blank => false,
                :member_label => Proc.new {|t| @export_type_map[t].pretty_name }
    %>

    <%= f.help_link :export_type do %>
        <h3>Available Export Types</h3>
        <ul>
          <% @export_types.each do |export_type| %>
              <% etype = @export_type_map[export_type] %>
              <% help_line = "#{etype.pretty_name}: #{etype.description}" %>
              <%= content_tag(:li, help_line) %>
          <% end %>
        </ul>
    <% end %>

<% end %>

apps/pro/ui/app/views/exports/_export_wrapper_form.html.erb
<div class="one_col_no_sidebar">
  <%= semantic_form_for [@workspace, @export] do |f| %>
      <%= f.hidden_field :workspace_id %>
      <%= render :partial => 'exports/export_type',      :locals => {:f => f} %>
      <%= render :partial => 'exports/export_name',      :locals => {:f => f} %>
      <%= render :partial => 'exports/address_settings', :locals => {:f => f} %>
      <%= render :partial => 'exports/export_options',   :locals => {:f => f} %>
      <%= render :partial => 'exports/submit_button',    :locals => {:f => f} %>
  <% end %>
</div>

apps/pro/ui/app/views/exports/_saved_exports.html.erb
<% include_javascript 'moment.min' %>

<div id="saved_exports">
	<h1>Saved Exports</h1>

	<table id="exports" class="list sortable">
		<thead>
			<tr>
				<th class="checkbox"><%= check_box_tag "all_exports" %></th>
				<th>File</th>
                <th>Export Type</th>
                <th>Creator</th>
                <th>Status</th>
                <th>Create Date</th>
				<th>Actions</th>
			</tr>
		</thead>
	</table>
</div>

apps/pro/ui/app/views/exports/_submit_button.html.erb
<%= f.actions do %>
    <span class="btn">
		<%= f.submit "Export Data", :class => "new" %>
    </span>
<% end -%>

apps/pro/ui/app/views/exports/index.html.erb
<% title "Exports" %>
<% breadcrumb workspace_link, exports_link %>

<% include_view_javascript -%>

<%= form_tag do %>
  <%= render :partial => "export_nav_bar" %>
  <%= render :partial => "saved_exports" %>
<% end %>

apps/pro/ui/app/views/exports/new.html.erb
<% title h('New Export') %>
<% include_stylesheet('exports') %>

<% breadcrumb workspace_link, exports_link, link_to("New Export", "#") %>

<div id='export_container'>
  <%= render :partial => 'exports/export_wrapper_form' %>
</div>